class Souris {
    static final int POIDS_PAR_DEFAUT = 20;
    static int nombreDeSourisVivantes = 0;

    String couleur;
    // le poids de la souris en gramme
    double poids;
    int pointsDeVie = 1;

    /*
     * int age; char sexe;
     */

    public Souris(String couleur) {
        nombreDeSourisVivantes++;
        this.couleur = couleur;
        this.poids = POIDS_PAR_DEFAUT;
    }

    public Souris(String couleur, double poids) {
        nombreDeSourisVivantes++;
        this.couleur = couleur;
        this.poids = poids;
    }

    /**
     * Fait évoluer la souris sur un temps élémentaire
     * 
     * TODO (biologiste): définir le temps élémentaire, ...
     **/
    public void evolue() {
        if (pointsDeVie == 0) {
            return;
        }
        poids -= 5;
        if (poids < 0) {
            poids = 0;
            meure();
        }
    }

    public void meure() {
        if (pointsDeVie == 0) {
            throw new RuntimeException("Ce n'est pas un chat! Une seule vie!");
        }
        poids = 0;
        pointsDeVie = 0;
        nombreDeSourisVivantes--;
    }

    public String toString() {
        if (pointsDeVie > 0) {
            return "Une souris " + couleur + " qui pèse " + poids + " g";
        } else {
            return "Une souris morte";
        }
    }

    public static void main(String[] args) {

        System.out.println("nombre de souris: " + nombreDeSourisVivantes);

        Souris sourisVerte = new Souris("verte");
        Souris sourisRose = new Souris("rose");
        Souris mickeyMouse = new Souris("jaune");
        System.out.println("nombre de souris: " + nombreDeSourisVivantes);
        Souris uneAutreSourisVerte = new Souris("verte");
        Souris aFatMouse = new Souris("verte", 300);
        System.out.println("nombre de souris: " + nombreDeSourisVivantes);
        System.out.println(sourisVerte);
        System.out.println(mickeyMouse);
        System.out.println(aFatMouse);
        aFatMouse.poids = 100;
        System.out.println(aFatMouse);

        for (int t = 0; t < 10; t++) {
            sourisVerte.evolue();
            System.out.println(sourisVerte);
        }
        System.out.println("nombre de souris: " + nombreDeSourisVivantes);
    }
}
